package game

import (
	"bitbucket.org/nimblebet/raystuff/internal/enum"
	rl "github.com/gen2brain/raylib-go/raylib"
)

type Config struct {
	Garden      GardenConfig
	TileSize    int32
	MapSize     int
	LabMapSize  rl.Vector2
	Textures    TexturesConfig
	Zoom        int32
	Composition ClassComposition
	Plants      []Plant
	FontRomulus rl.Font
}

type ClassComposition struct {
	Family         map[enum.PlantFamily]int
	Height         map[enum.PlantHeight]int
	CalorificValue map[enum.PlantCalorificValue]int
}

type GardenConfig struct {
	CellSize     int32
	ColumnsCount int32
	RowsCount    int32
}

type TexturesConfig struct {
	GardenBackground rl.Texture2D
	PlantActive      rl.Texture2D
	PlantInactive    rl.Texture2D
	MainBottleEmpty  rl.Texture2D
	MainBottleFull   rl.Texture2D
	LoseBackground   rl.Texture2D
	WinBackground    rl.Texture2D
	GrownPlant       rl.Texture2D
	Fact             rl.Texture2D
	PlayerTexture    rl.Texture2D
	TileSet          []rl.Texture2D
	Botles           BottlesTextures
	BotlesRand       []rl.Texture2D
	City             rl.Texture2D
	Lab              rl.Texture2D
	TaskWindow       rl.Texture2D
}

type BottlesTextures struct {
	Blue   rl.Texture2D
	Green  rl.Texture2D
	Orange rl.Texture2D
	Pink   rl.Texture2D
}
