package game

import (
	"bitbucket.org/nimblebet/raystuff/internal/enum"
	rl "github.com/gen2brain/raylib-go/raylib"
)

type State struct {
	Username      string
	World         World
	Briefing      Briefing
	CurrentScreen enum.Screen
	CurrentLevel  int
	LevelPassed   LevelPassed
	CurrentSong   rl.Music
	DoomsdaySong  rl.Music
	FinalSong     rl.Music
	WinSplash     rl.Music
	LoseSplash    rl.Music
}

type LevelPassed struct {
	Plant Plant
}

type Briefing struct {
	Step int
}

type World struct {
	Garden      Garden
	Map         [][]int
	Player      Entity
	IsFinal     bool
	PlantToGrow Plant
	Lab         Lab
	Message     Message
}

type Lab struct {
	SelectedSubstance enum.SubstanceType
}

type Entity struct {
	Substances map[enum.SubstanceType]Substance
	WorkTube   WorkTube
	Position   rl.RectangleInt32
}

type WorkTube struct {
	Size     int
	Fullness int
}

type Message struct {
	Text string
}

type Substance struct {
	StockLevel      int
	MeasuredCurStep int
	Type            enum.SubstanceType
	Texture         rl.Texture2D
	Position        rl.Vector2
}

type Garden struct {
	ColumnsCount      int32
	RowsCount         int32
	Cells             []GardenCell
	CurrentCellIndex  int32
	SelectedCellIndex int32
}

type GardenCell struct {
	//Kind enum.InventoryCellKind
	Plant Plant
}

//
//type InventoryItem struct {
//	// TODO: implement items
//}

type Plant struct {
	Name           string
	Description    string
	Family         enum.PlantFamily
	Height         enum.PlantHeight
	CalorificValue enum.PlantCalorificValue
}
