package initializer

import (
	"bitbucket.org/nimblebet/raystuff/internal/game"
	"bitbucket.org/nimblebet/raystuff/internal/mutator"
	"bitbucket.org/nimblebet/raystuff/internal/mux"
)

func GardenMux() func(game.Config, game.State) game.State {
	eventProcessor := mux.EventProcessor(
		[]mux.Event{
			mux.Event{
				Handler: mutator.GardenSelectPreviousCell,
			},
			mux.Event{
				Handler: mutator.GardenSelectNextCell,
			},
			mux.Event{
				Handler: mutator.GardenSelectNextRow,
			},
			mux.Event{
				Handler: mutator.GardenSelectPreviousRow,
			},
			//mux.Event{
			//	Handler: mutator.ExitInventory,
			//},
		},
	)

	return eventProcessor
}
