package initializer

import (
	"bitbucket.org/nimblebet/raystuff/internal/game"
	"bitbucket.org/nimblebet/raystuff/internal/mutator"
	"bitbucket.org/nimblebet/raystuff/internal/mux"
)

func LabMux() func(game.Config, game.State) game.State {
	eventProcessor := mux.EventProcessor(
		[]mux.Event{
			mux.Event{
				Handler: mutator.LabMixIngredients,
			},
			mux.Event{
				Handler: mutator.LabSelectSubstance,
			},
			mux.Event{
				Handler: mutator.LabMeasureSubstance,
			},
			mux.Event{
				Handler: mutator.TaskWindowOpen,
			},
		},
	)

	return eventProcessor
}
