package layer

import (
	"bitbucket.org/nimblebet/raystuff/internal/game"
	rl "github.com/gen2brain/raylib-go/raylib"
)

func Briefing(c game.Config, s game.State) {
	rl.UpdateMusicStream(s.DoomsdaySong)

	y := int32(32)
	x := int32(rl.GetScreenWidth()/2 - 512/2)

	rl.DrawTexture(c.Textures.City, x, y, rl.White)

	text := `STORY [1/3]

Since humanity stopped care about the ecology,
Earth had become a lifeless rock without a single
plant or tree. You are the only capable scientist
left alone in The Lab. Your MISSION is to recreate
seeds of different plants to save the Earth's and
REPAIR its ecology.`

	switch s.Briefing.Step {
	case 1:
		text = `HOW TO PLAY? [2/3]
	
Mix up available chemicals at the TABLE.
Plant the seeds You have synthesized in the GARDEN.
Each LEVEL it becomes harder and harder.`

	case 2:

		text = `RECOMMENDATIONS [3/3]

Follow the 3R rule to make it a bit easier.

1. REDUCE the amount of the reagent You use,
   since it is limited.
2. REUSE liquids, if possible.
3. RECYCLE the chemicals You used, pollution
   is not allowed!`

	}

	rl.DrawTextEx(c.FontRomulus, text, rl.Vector2{32, float32(y + 256 + 64)}, float32(c.FontRomulus.BaseSize*c.Zoom), float32(1*c.Zoom), rl.White)
	rl.DrawText("Press RIGHT to continue", 32, int32(rl.GetScreenHeight()-20-32), 20, rl.White)

}
