package layer

import (
	"bitbucket.org/nimblebet/raystuff/internal/game"
	"fmt"
	rl "github.com/gen2brain/raylib-go/raylib"
	"reflect"
)

func Garden(c game.Config, s game.State) {
	rl.DrawText("Garden ", 30, 30, 20, rl.White)

	y := int32(32)
	x := int32(rl.GetScreenWidth()/2 - 512/2)

	rl.DrawTextureEx(c.Textures.GardenBackground, rl.NewVector2(float32(x), float32(y)), 0, 2, rl.White)
	//rl.DrawRectangle(x, y, 512, 256, rl.Red)

	wW := int32(rl.GetScreenWidth())

	gardenWidth := c.Garden.CellSize * c.Garden.ColumnsCount
	posY := y + 256 + 20
	posX := (wW / 2) - (gardenWidth / 2)

	rl.DrawRectangleLines(posX-2, posY-2, gardenWidth+4, c.Garden.CellSize*c.Garden.RowsCount+4, rl.White)

	counter := int32(0)

	for iy := int32(0); iy < c.Garden.RowsCount; iy++ {
		for ix := int32(0); ix < c.Garden.ColumnsCount; ix++ {

			filter := rl.Gray
			if counter == s.World.Garden.CurrentCellIndex {
				filter = rl.DarkGray
			}

			// Draw recipe
			selectedCell := s.World.Garden.Cells[s.World.Garden.CurrentCellIndex]
			if !reflect.ValueOf(selectedCell.Plant).IsZero() {
				rl.DrawRectangle(wW/2-250/2, posY+c.Garden.CellSize*c.Garden.RowsCount+20, 250, 150, rl.White)

				recipe := fmt.Sprintf("Family: %v\nHeight: %v\nCalorificValue: %v", selectedCell.Plant.Family, selectedCell.Plant.Height, selectedCell.Plant.CalorificValue)

				rl.DrawText(recipe, wW/2-250/2+15, posY+c.Garden.CellSize*c.Garden.RowsCount+25, 20, rl.Black)

			}

			cellTx := c.Textures.PlantInactive

			currentCell := s.World.Garden.Cells[counter]
			if !reflect.ValueOf(currentCell).IsZero() {
				if counter == s.World.Garden.CurrentCellIndex {
					filter = rl.White
				}
				
				cellTx = c.Textures.PlantActive
			}

			cellTx.Width = c.Garden.CellSize
			cellTx.Height = c.Garden.CellSize

			rl.DrawTexture(cellTx, posX+c.Garden.CellSize*ix, posY+c.Garden.CellSize*iy, filter)
			rl.DrawRectangleLines(posX+c.Garden.CellSize*ix, posY+c.Garden.CellSize*iy, c.Garden.CellSize, c.Garden.CellSize, rl.Red)

			counter++
		}

	}

	rl.DrawText("[F] - go to the lab", 30, int32(rl.GetScreenHeight()-25), 20, rl.White)
}
