package layer

import (
	"bitbucket.org/nimblebet/raystuff/internal/enum"
	"fmt"

	"bitbucket.org/nimblebet/raystuff/internal/game"
	rl "github.com/gen2brain/raylib-go/raylib"
)

func Lab(c game.Config, s game.State) {
	y := int32(32)
	x := int32(rl.GetScreenWidth()/2 - 512/2)

	rl.DrawTexture(c.Textures.Lab, x, y, rl.White)

	for i := 1; i <= len(s.World.Player.Substances); i++ {
		subs := s.World.Player.Substances[enum.SubstanceType(i)]

		rl.DrawTextureV(subs.Texture, subs.Position, rl.White)

		if i == int(s.World.Lab.SelectedSubstance) {
			rl.DrawLineEx(rl.NewVector2(subs.Position.X, subs.Position.Y-10), rl.NewVector2(subs.Position.X+float32(subs.Texture.Width-10), subs.Position.Y-10), 5, rl.Red)
		}

		rl.DrawText(fmt.Sprintf("%v%%", subs.StockLevel), int32(subs.Position.X+10), int32(subs.Position.Y+60), 20, rl.White)
	}

	wortubeTx := c.Textures.MainBottleEmpty
	if s.World.Player.WorkTube.Fullness > 0 {
		wortubeTx = c.Textures.MainBottleFull
	}

	rl.DrawTexture(wortubeTx, 370, 450, rl.White)

	rl.DrawText(fmt.Sprintf("%v%%", s.World.Player.WorkTube.Fullness), 390, 520, 20, rl.White)

	rl.DrawText("[F] - go to the garden", 30, int32(rl.GetScreenHeight()-20-32), 20, rl.White)
}
