package layer

import (
	"fmt"

	"bitbucket.org/nimblebet/raystuff/internal/game"
	rl "github.com/gen2brain/raylib-go/raylib"
)

func LevelPassed(c game.Config, s game.State) {
	y := float32(32)
	x := float32(rl.GetScreenWidth()/2 - 512/2)

	rl.DrawTextureEx(c.Textures.GrownPlant, rl.NewVector2(x, y), 0, 2, rl.White)

	rl.DrawTextureEx(c.Textures.Fact, rl.NewVector2(float32(x), float32(y)+15+float32(c.Textures.City.Height)), 0, 2, rl.White)

	text := fmt.Sprintf("You have grown %v.", s.World.PlantToGrow.Name)
	rl.DrawText(text, int32(x)+20, int32(y)+15+int32(c.Textures.City.Height)+20, 20, rl.Green)

	text = fmt.Sprintf("Interesting fact about %v:\n%v", s.World.PlantToGrow.Name, s.World.PlantToGrow.Description)
	rl.DrawText(text, int32(x)+20, int32(y)+15+int32(c.Textures.City.Height)+60, 20, rl.White)

	rl.DrawText("Press ENTER to continue", 30, int32(rl.GetScreenHeight()-20-32), 20, rl.White)
}
