package mutator

import (
	"bitbucket.org/nimblebet/raystuff/internal/enum"
	"bitbucket.org/nimblebet/raystuff/internal/game"
	rl "github.com/gen2brain/raylib-go/raylib"
)

func LabMeasureSubstance(c game.Config, s game.State) game.State {
	step := 10
	subs := s.World.Player.Substances[enum.SubstanceType(s.World.Lab.SelectedSubstance)]

	if rl.IsKeyPressed(rl.KeyUp) {
		if subs.StockLevel+step >= subs.StockLevel && subs.MeasuredCurStep > 0 {
			subs.StockLevel += step
			subs.MeasuredCurStep -= step
			s.World.Player.WorkTube.Fullness -= step
			s.World.Player.Substances[s.World.Lab.SelectedSubstance] = subs
		}
	}

	if rl.IsKeyPressed(rl.KeyDown) {
		if subs.StockLevel-step >= 0 && s.World.Player.WorkTube.Fullness < s.World.Player.WorkTube.Size {
			subs.StockLevel -= step
			subs.MeasuredCurStep += step
			s.World.Player.WorkTube.Fullness += step
			s.World.Player.Substances[s.World.Lab.SelectedSubstance] = subs
		}
	}

	//fmt.Println(s.World.Player.Substances)

	return s
}
