package mutator

import (
	"bitbucket.org/nimblebet/raystuff/internal/enum"
	"bitbucket.org/nimblebet/raystuff/internal/game"
	rl "github.com/gen2brain/raylib-go/raylib"
)

func LabMixIngredients(c game.Config, s game.State) game.State {
	var success bool

	if rl.IsKeyPressed(rl.KeyEnter) {
		if s.World.Player.Substances[enum.FamilyType].MeasuredCurStep == 0 ||
			s.World.Player.Substances[enum.HeightType].MeasuredCurStep == 0 ||
			s.World.Player.Substances[enum.CalorificValueType].MeasuredCurStep == 0 {
			s.World.Message.Text = "Must use all of three substances"
			return s
		}

		if c.Composition.Family[s.World.PlantToGrow.Family] == s.World.Player.Substances[enum.FamilyType].MeasuredCurStep &&
			c.Composition.Height[s.World.PlantToGrow.Height] == s.World.Player.Substances[enum.HeightType].MeasuredCurStep &&
			c.Composition.CalorificValue[s.World.PlantToGrow.CalorificValue] == s.World.Player.Substances[enum.CalorificValueType].MeasuredCurStep {
			success = true
		}

		if !success {
			if s.World.Player.Substances[enum.FamilyType].StockLevel > 0 &&
				s.World.Player.Substances[enum.HeightType].StockLevel > 0 &&
				s.World.Player.Substances[enum.CalorificValueType].StockLevel > 0 {
				s.World.Player.WorkTube.Fullness = 0
				for subType, _ := range s.World.Player.Substances {
					subsst := s.World.Player.Substances[subType]
					subsst.MeasuredCurStep = 0
					s.World.Player.Substances[subType] = subsst
				}

				s.World.Message.Text = "Wrong formula. Try again."

				return s
			}

			s.CurrentScreen = enum.Lose
			s.CurrentSong = s.LoseSplash
			rl.StopMusicStream(s.CurrentSong)
			rl.PlayMusicStream(s.CurrentSong)

			return s
		}

		if success {
			s.CurrentScreen = enum.LevelPassed
			s.CurrentSong = s.WinSplash
			rl.StopMusicStream(s.CurrentSong)
			rl.PlayMusicStream(s.CurrentSong)

			return s
		}

		s.CurrentScreen = enum.LevelPassed
		return s
	}

	return s
}
