package mutator

import (
	"reflect"

	"bitbucket.org/nimblebet/raystuff/internal/enum"
	"bitbucket.org/nimblebet/raystuff/internal/game"
	rl "github.com/gen2brain/raylib-go/raylib"
)

func NextLevel(c game.Config, s game.State) game.State {
	if rl.IsKeyPressed(rl.KeyEnter) {
		if s.CurrentLevel == len(c.Plants) {
			s.CurrentScreen = enum.Win
			s.CurrentSong = s.FinalSong
			rl.StopMusicStream(s.CurrentSong)
			rl.PlayMusicStream(s.CurrentSong)

			return s
		}

		s.CurrentLevel++

		for i := 0; i < len(s.World.Garden.Cells); i++ {
			if reflect.ValueOf(s.World.Garden.Cells[i]).IsZero() {
				s.World.Garden.Cells[i] = game.GardenCell{
					Plant: s.World.PlantToGrow,
				}

				break
			}
		}
		s.World.PlantToGrow = c.Plants[s.CurrentLevel-1]

		s.World.Player.WorkTube.Fullness = 0

		for idx, _ := range s.World.Player.Substances {
			subs := s.World.Player.Substances[idx]
			subs.StockLevel = 100
			subs.MeasuredCurStep = 0

			s.World.Player.Substances[idx] = subs
		}

		s.CurrentScreen = enum.Lab
		s.CurrentSong = s.DoomsdaySong
		rl.StopMusicStream(s.CurrentSong)
		rl.PlayMusicStream(s.CurrentSong)
	}

	return s
}
