package mux

import (
	"bitbucket.org/nimblebet/raystuff/internal/game"
)

type Event struct {
	Handler func(game.Config, game.State) game.State
}

func EventProcessor(events []Event) func(c game.Config, state game.State) game.State {
	return func(c game.Config, state game.State) game.State {
		newState := state
		for _, event := range events {
			newState = event.Handler(c, newState)
		}

		return newState
	}
}
